var map;

var layerWMS;
var layerOSM;
var overlay;
var posizione_iniziale_da_impostare = true;
var info_posizione_iniziale_dinamica = false;
var editingactive = false;
var routeactive = false;
var startrouting = false;
var endrouting = false;
var startroutingpoint;
var endroutingpoint;

var startcontent;
var endcontent;

var is_mobile = false;
var idSearchInput;
var restCallReturned = true;

var watchPositionRef;
var sourceGeoLocalization;
var showErrorToastFunc;

var isFirstLocation = true;
var locationInterval = [];
var firstLocationInterval

function initMap(geolocation, showErrorToastFN) {
	luogo_iniziale = 'Salerno'
	isFirstLocation = true;
	posizione_iniziale_da_impostare = true;

	locationInterval = []
	showErrorToastFunc = showErrorToastFN
	if (!document.getElementById('map')) return;
	window.addEventListener('resize', function (event) {
		setSizeMap();
	});
	try {

		if (document.getElementById('map').innerHTML.trim().length > 0) {
			luogo_iniziale = document.getElementById('map').innerHTML;
			info_posizione_iniziale_dinamica = true;
		}

		document.getElementById('map').innerHTML =
			"<div id=\"controlPanel\" class=\"box\" >" +
			"<div id=\"search-container\" class=\"search-container\">" +
			"<div id=\"commands-container\" > </div>" +
			"<div id=\"searchForm-container\" > </div>" +
			"<div  id=\"destForm-container\" > </div>" +
			"<div id=\"typeRoute-container\" > </div>" +
			"<div id=\"infoRoute-container\" > </div>" +
			"</div>" +
			"<div id=\"results\" ></div>" +
			"</div>" +
			"<div id=\"popup\" class=\"ol-popup\">" +
			"<a href=\"#\" id=\"popup-closer\" class=\"ol-popup-closer\"></a>" +
			"<div id=\"popup-content\" ></div>" +
			"</div>";

		document.querySelector('#commands-container').innerHTML =
			/*TODO 
			"<button class=\"olButtonThisCle\" id=\"buttonClearMakers\" ><img src=\"" + pathImages + "clear.png\" width=\"20\" title=\"pulisci mappa\" ></button>"+ */
			"<button class=\"olButtonThisCle\" id=\"buttonEditing\" ><img src=\"" + pathImages + "modify.png\" width=\"20\" title=\"salva posizione\" ></button>" +
			"<button class=\"olButtonThisCle\" id=\"buttonRoute\" ><img src=\"" + pathImages + "route.png\" width=\"20\" title=\"crea percorso\" ></button>";
		/*TODO 
	   "<button class=\"olButtonThisCat\" id=\"buttonCategories\" title=\"luoghi predefiniti\" >Luoghi</button>"; */

		document.querySelector('#typeRoute-container').innerHTML =
			"<button class=\"olButtonRoutTypeAct\" id=\"buttonRoutType1\" ><img src=\"" + pathImages + "auto.png\" width=\"20\" title=\"Autovetture\"></button>" +
			"<button class=\"olButtonRoutType\"    id=\"buttonRoutType2\" ><img src=\"" + pathImages + "mezzi_pesanti.png\" width=\"20\" title=\"Mezzi pesanti\"></button>" +
			"<button class=\"olButtonRoutType\"    id=\"buttonRoutType3\" ><img src=\"" + pathImages + "bike.png\" width=\"20\" title=\"Bicicletta\"></button>" +
			"<button class=\"olButtonRoutType\"    id=\"buttonRoutType4\" ><img src=\"" + pathImages + "moto.png\" width=\"20\" title=\"Motocicletta\"></button>" +
			"<button class=\"olButtonRoutType\"    id=\"buttonRoutType5\" ><img src=\"" + pathImages + "piedi.png\" width=\"20\" title=\"A piedi\"></button>	";

		document.querySelector('#searchForm-container').innerHTML =
			"<form id=\"searchForm\">" +
			"<input type=\"search\" id=\"search\" placeholder=\"Cerca...\"  autocomplete=\"off\" /> " +
			"</form>" +
			"<button class=\"icon search\"><i class=\"fa fa-search\"></i></button>	";

		document.querySelector('#destForm-container').innerHTML =
			"<form id=\"destForm\">" +
			"<input type=\"dest\" id=\"dest\" placeholder=\"Scegli la destinazione...\" style=\"\" autocomplete=\"off\" />" +
			"</form>" +
			"<button class=\"icon dest\"><i class=\"fa fa-search\"></i></button>";

		document.querySelector('#search-container').innerHTML =
			document.querySelector('#search-container').innerHTML +
			"<div class=\"olButtonStartRout\" id=\"buttonStartRout\" ><img src=\"" + pathImages + "play.png\" width=\"29\" title=\"Avvia navigazione\"></div>";

	} catch (err) { console.log(err); }


	if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
		is_mobile = true;
		document.querySelector('#buttonStartRout').addEventListener('click', function (e) {
			if (endroutingpoint != null)
				startNavigation(typerouting, null, null, endroutingpoint.lat, endroutingpoint.lon);
		});
	}


	layerWMS = new ol.layer.Tile({
		source: new ol.source.TileWMS()
	});

	layerOSM = new ol.layer.Tile({
		source: new ol.source.OSM()
	});


	var attribution = new ol.control.Attribution({
		collapsible: false
	});


	overlay = new ol.Overlay({
		element: document.getElementById('popup'),
		autoPan: true,
		autoPanAnimation: {
			duration: 250,
		},
	});



	setSizeMap();

	if (is_mobile) {
		map = new ol.Map({
			controls: ol.control.defaults({ attribution: false, zoom: false }).extend([attribution]),
			target: 'map',
			layers: [
				layerOSM,
				layerWMS,
			],
			overlays: [overlay],
			view: new ol.View({
				center: ol.proj.fromLonLat([longitudine_iniziale, latitudine_iniziale]),
				zoom: zoom_iniziale
			})
		});
	} else {
		map = new ol.Map({
			controls: ol.control.defaults({ attribution: false }).extend([attribution]),
			target: 'map',
			layers: [
				layerOSM,
				layerWMS,
			],
			overlays: [overlay],
			view: new ol.View({
				center: ol.proj.fromLonLat([longitudine_iniziale, latitudine_iniziale]),
				zoom: zoom_iniziale
			})
		});
	}

	addSourceToMap(map)
	// setCurrentPosition(geolocation)
	watchPosition(geolocation)
	addGeolocationBtn()




	// init position da config.js o contenuto dinamico

	if (luogo_iniziale != null) setTimeout(() => geocodeRestSearch(luogo_iniziale, null), 1000);
	else setPosition();

	if (categoria_luogo_iniziale != null) {
		// il tempo che risponderà prima chiamata per l'impostazione della posizione iniziale
		setTimeout(function () { geocodeRestSearch(null, categoria_luogo_iniziale) }, 1000);
	}

	/*TODO 	
	document.querySelector('#buttonClearMakers').addEventListener('click', function(e) {
		overlay.setPosition(undefined);

		clearLayers();
		
		document.getElementById("results").style.display='none';
		document.querySelector('#buttonRoute').className="olButtonThisCle";
		document.querySelector('#search').placeholder="Cerca...";
		document.querySelector('#typeRoute-container').style.display="none";
		document.getElementById("infoRoute-container").style.display="none";
		document.getElementById("buttonStartRout").style.display="none";
		document.querySelector('#destForm-container').style.display="none";	
		routeactive=false;
		startroutingpoint=null;
		endroutingpoint=null;
	});	 */

	document.querySelector('#popup-closer').onclick = function () {
		overlay.setPosition(undefined);
		this.blur();
		return false;
	};


	document.querySelector('#searchForm').addEventListener('submit', function (e) {
		idSearchInput = "#search";
		if (routeactive) {
			startrouting = true;
			endrouting = false;
		}
		geocodeRestSearch(e.target.children.namedItem('search').value);
		e.preventDefault();
		return false; // prevent page reload
	});
	document.querySelector('button.search').addEventListener('click', function (e) {
		document.getElementById("results").innerHTML = "";
		idSearchInput = "#search";
		if (routeactive) {
			startrouting = true;
			endrouting = false;
		}
		else document.getElementById("results").style.top = '70px';
		geocodeRestSearch(document.querySelector('#search').value);
	});
	document.querySelector('#search').addEventListener('keyup', function (e) {
		document.getElementById("results").innerHTML = "";
		var n = (window.Event) ? e.which : e.keyCode;
		if (n == 8) return false;
		idSearchInput = "#search";
		if (routeactive) {
			startrouting = true;
			endrouting = false;
		}
		else document.getElementById("results").style.top = '70px';
		var valuesearch = document.querySelector('#search').value;
		if (valuesearch.length > 2) {
			searchString = valuesearch;
			if (restCallReturned == true) {
				geocodeRestSearch(valuesearch);
				setTimeout(function () { document.querySelector('button.search').click(); }, 1000);
			}
		}
	});
	document.querySelector('#search').value = "";




	document.querySelector('#destForm').addEventListener('submit', function (e) {
		idSearchInput = "#dest";
		if (routeactive) {
			startrouting = false;
			endrouting = true;
		}
		geocodeRestSearch(e.target.children.namedItem('dest').value);
		e.preventDefault();
		return false; // prevent page reload
	});
	document.querySelector('button.dest').addEventListener('click', function (e) {
		idSearchInput = "#dest";
		if (routeactive) {
			startrouting = false;
			endrouting = true;
		}
		geocodeRestSearch(document.querySelector('#search').value);
	});
	document.querySelector('#dest').addEventListener('keyup', function (e) {
		idSearchInput = "#dest";
		if (routeactive) {
			startrouting = false;
			endrouting = true;
		}
		var valuesearch = document.querySelector('#dest').value;
		document.getElementById("results").innerHTML = "";
		if (valuesearch.length > 2) {
			searchString = valuesearch;
			if (restCallReturned == true) {
				geocodeRestSearch(valuesearch);
			}
		}
	});
	document.querySelector('#dest').value = "";

	if (categorie_luoghi.length > 0) {
		// pulsante LUOGHI PREDEFINITI
		/* 	document.querySelector('#buttonCategories').addEventListener('click', function(e) {

				document.getElementById("results").style.top='70px';
				document.getElementById("results").innerHTML="";
				document.getElementById("results").style.display='block';
				document.querySelector('#buttonRoute').className="olButtonThisCle";
				document.querySelector('#typeRoute-container').style.display="none";
				document.getElementById("infoRoute-container").style.display="none";
				document.getElementById("buttonStartRout").style.display="none";
				document.querySelector('#destForm-container').style.display="none";
				document.querySelector('#search').placeholder="Cerca...";
				
				routeactive=false;
				startroutingpoint=null;
				endroutingpoint=null;
				//TODO
				for (var i=0; i<categorie_luoghi.length; i++){
					div = document.createElement("div");
					div.className = "olButtonThis";
					div.id = 'catbut' + i;
					div.innerHTML = categorie_luoghi_tradotti[i];
					
					div.onclick = function(evt) { 
						clearLayers();
						document.getElementById("results").style.display='none';
																	 
						geocodeRestSearch(null, categorie_luoghi[parseInt(this.id.replace("catbut",""))].replace(/ /g, '_'));

					}; 	

					document.getElementById("results").appendChild(div);
					
				}
				
			}); */

	}
	else {
		/*TODO 
		document.querySelector('#buttonCategories').style.display="none"; */
		/* TODO
		document.querySelector('#buttonClearMakers').style.display="none"; */
	}


	document.querySelector('#buttonEditing').addEventListener('click', function (e) {
		document.getElementById("results").style.display = 'none';
		if (editingactive == false) {
			editingactive = true;
			document.querySelector('#buttonEditing').className = "olButtonThisEdtAct";
			document.querySelector('#buttonRoute').className = "olButtonThisCle";
			document.querySelector('#search').placeholder = "Cerca...";
			document.querySelector('#typeRoute-container').style.display = "none";
			document.getElementById("infoRoute-container").style.display = "none";
			document.getElementById("buttonStartRout").style.display = "none";
			document.querySelector('#destForm-container').style.display = "none";
			clearLayers();
			routeactive = false;
			startroutingpoint = null;
			endroutingpoint = null;

			last_response_selected = null;
		}
		else {
			editingactive = false;
			document.querySelector('#buttonEditing').className = "olButtonThisCle";
			overlay.setPosition(undefined);
		}
	});


	document.querySelector('#buttonRoute').addEventListener('click', function (e) {
		document.getElementById("results").style.top = '170px';
		document.getElementById("results").style.display = 'none';
		startroutingpoint = null;
		endroutingpoint = null;
		if (routeactive == false) {
			editingactive = false;
			document.querySelector('#buttonEditing').className = "olButtonThisCle";
			last_response_selected = null;
			routeactive = true;
			typerouting = "driving-car";

			clearLayers();
			document.querySelector('#buttonRoute').className = "buttonRouteAct";
			document.querySelector('#search').value = "";
			document.querySelector('#search').placeholder = "Scegli da dove...";
			document.querySelector('#search').focus();
			document.querySelector('#typeRoute-container').style.display = "block";
			document.querySelector('#dest').value = "";
			document.querySelector('#destForm-container').style.display = "block";
			overlay.setPosition(undefined);
			document.querySelector('#buttonRoutType1').click();
		}
		else {
			routeactive = false;

			clearLayers();
			document.querySelector('#buttonRoute').className = "olButtonThisCle";
			document.querySelector('#search').value = "";
			document.querySelector('#search').placeholder = "Cerca...";
			document.querySelector('#typeRoute-container').style.display = "none";
			document.getElementById("infoRoute-container").style.display = "none";
			document.getElementById("buttonStartRout").style.display = "none";
			document.querySelector('#destForm-container').style.display = "none";
			overlay.setPosition(undefined);
			startrouting = false;
			endrouting = false;
		}
	});


	document.querySelector('#buttonRoutType1').addEventListener('click', function (e) {
		this.className = "olButtonRoutTypeAct";
		typerouting = "driving-car";
		document.querySelector('#buttonRoutType2').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType3').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType4').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType5').
			className = "olButtonRoutType";
		clearLayers();
		if (startroutingpoint != null && endroutingpoint != null) {
			geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
			setStartStopIcon(startroutingpoint, endroutingpoint);
		}
	});

	document.querySelector('#buttonRoutType2').addEventListener('click', function (e) {
		this.className = "olButtonRoutTypeAct";
		typerouting = "driving-hgv";
		document.querySelector('#buttonRoutType1').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType3').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType4').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType5').className = "olButtonRoutType";
		clearLayers();
		if (startroutingpoint != null && endroutingpoint != null) {
			geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
			setStartStopIcon(startroutingpoint, endroutingpoint);
		}
	});

	document.querySelector('#buttonRoutType3').addEventListener('click', function (e) {
		this.className = "olButtonRoutTypeAct";
		typerouting = "cycling-regular";
		document.querySelector('#buttonRoutType1').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType2').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType4').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType5').className = "olButtonRoutType";
		clearLayers();
		if (startroutingpoint != null && endroutingpoint != null) {
			geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
			setStartStopIcon(startroutingpoint, endroutingpoint);
		}
	});

	document.querySelector('#buttonRoutType4').addEventListener('click', function (e) {
		this.className = "olButtonRoutTypeAct";
		typerouting = "cycling-road";
		document.querySelector('#buttonRoutType1').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType2').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType3').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType5').className = "olButtonRoutType";
		clearLayers();
		if (startroutingpoint != null && endroutingpoint != null) {
			geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
			setStartStopIcon(startroutingpoint, endroutingpoint);
		}
	});

	document.querySelector('#buttonRoutType5').addEventListener('click', function (e) {
		this.className = "olButtonRoutTypeAct";
		typerouting = "foot-walking";
		document.querySelector('#buttonRoutType1').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType2').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType3').className = "olButtonRoutType";
		document.querySelector('#buttonRoutType4').className = "olButtonRoutType";
		clearLayers();
		if (startroutingpoint != null && endroutingpoint != null) {
			geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
			setStartStopIcon(startroutingpoint, endroutingpoint);
		}
	});



	map.on(is_mobile ? 'touchend' : 'click', function (evt) {
		if (editingactive) {

			document.getElementById('popup-content').innerHTML = getContentSave(evt.coordinate[0], evt.coordinate[1]);
			overlay.setPosition(evt.coordinate);

			document.querySelector('#buttonSavePlace').addEventListener('click', function (e) {
				var select = document.getElementById("type_amenity");
				var svalue = "";
				try { select.options[select.selectedIndex].value; } catch (err) { }

				var json = "{ ";
				json += " 	\"display_name\" : \"" + document.getElementById("display_name").value + "\", ";
				json += " 	\"road\" : \"" + document.getElementById("road").value + "\", ";
				json += " 	\"city\" : \"" + document.getElementById("city").value + "\", ";
				json += " 	\"neighborhood\" : \"" + document.getElementById("neighborhood").value + "\", ";
				json += " 	\"region\" : \"" + document.getElementById("region").value + "\", ";
				json += " 	\"country\" : \"" + document.getElementById("country").value + "\", ";
				json += " 	\"country_code\" : \"" + document.getElementById("country_code").value + "\", ";
				json += " 	\"postal_code\" : \"" + document.getElementById("postal_code").value + "\", ";
				json += " 	\"phone\" : \"" + document.getElementById("phone").value + "\", ";
				json += " 	\"website\" : \"" + document.getElementById("website").value + "\", ";
				json += " 	\"lat\" : " + document.getElementById("lat").value.split(" ")[1] + ", ";
				json += " 	\"lon\" : " + document.getElementById("lon").value.split(" ")[1] + ", ";
				json += " 	\"type_amenity\" : \"" + svalue + "\" ";
				json += "} ";
				saveNewPlaceMap(JSON.parse(json));

				overlay.setPosition(undefined);
			});
		}

		if (!routeactive) document.getElementById("results").style.display = 'none';

	});


	/*TOD if (buttons_actived.includes("buttonClearMakers") == false) document.getElementById("buttonClearMakers").style.display='none'; */
	if (buttons_actived.includes("buttonEditing") == false) document.getElementById("buttonEditing").style.display = 'none';
	if (buttons_actived.includes("buttonRoute") == false) document.getElementById("buttonRoute").style.display = 'none';
	/*TODO 
	if (buttons_actived.includes("buttonCategories") == false) document.getElementById("buttonCategories").style.display='none'; */
}

function clearLayers() {
	layers = map.getLayers().getArray();
	for (var i = 0; i < layers.length; i++) {
		layer = layers[i];
		if (layer && layer.get('name') && (layer.get('name').startsWith('Marker') || layer.get('name').startsWith('Routing'))) {
			map.removeLayer(layer);
			delete layer
			i--;
		}
	}
	overlay.setPosition(undefined);

}

function setPosition() {
	map.getView().setCenter(ol.proj.transform([longitudine_iniziale, latitudine_iniziale], 'EPSG:4326', 'EPSG:3857'));
	map.getView().animate({
		zoom: zoom_iniziale,
		duration: 1000
	})
	posizione_iniziale_da_impostare = false;
}

var multi_markers_PRESSED = null;
var searchString;
//TODO
function geocodeRestSearch(searchStr, multi_markers_amenity) {
	//ADD -AND
	multi_markers_amenity !== 'xb' ? document.getElementById("results").innerHTML = "" : 0;
	var url = null;
	if (posizione_iniziale_da_impostare && info_posizione_iniziale_dinamica == false) {
		url = 'https://nominatim.openstreetmap.org/search' +
			'?city=' + searchStr +
			'&format=json' +
			'&limit=1';
		searchString = null;
	}
	else if (info_posizione_iniziale_dinamica) {
		url = 'https://nominatim.openstreetmap.org/search?addressdetails=1&extratags=1&limit=1&bounded=1' +
			"&q=" + luogo_iniziale.replace(/_/g, '%20') +
			'&format=json';
		searchString = null;
	}
	else if (multi_markers_amenity) {
		var bounds = map.getView().calculateExtent(map.getSize());
		bbox1 = ol.proj.transform([bounds[0], bounds[1]], 'EPSG:3857', 'EPSG:4326');
		bbox2 = ol.proj.transform([bounds[2], bounds[3]], 'EPSG:3857', 'EPSG:4326');
		url = 'https://nominatim.openstreetmap.org/search?addressdetails=1&extratags=1&limit=20&bounded=1' +
			"&street=" + multi_markers_amenity.replace(/_/g, '%20') +
			/* '&viewbox=' + bbox1 + ',' + bbox2 + */
			'&format=json&city=Salerno&countrycodes=it&exclude_place_ids=23844456';
		/* street=bar&city=Salerno */
		multi_markers_PRESSED = multi_markers_amenity;
		searchString = null;
	}
	else {
		if (searchStr === null) {
			searchStr = ''
		}
		url = 'https://nominatim.openstreetmap.org/search' +
			'?q=' + searchStr.replace(/ /g, '%20') +
			'&addressdetails=1&extratags=1&format=json&limit=8';
		restCallReturned = false;
	}
	var req = window.superagent;
	req.get(url, restGeoSearchResponse);
}

var last_response_selected;
var last_response_received;
function restGeoSearchResponse(response) {
	overlay.setPosition(undefined);
	var responseJson = JSON.parse(response.text);
	if (posizione_iniziale_da_impostare && info_posizione_iniziale_dinamica == false) {
		latitudine_iniziale = responseJson[0].lat;
		longitudine_iniziale = responseJson[0].lon;
		setPosition();
	}
	else {

		// nel caso si clicca sulla categoria markers
		if (multi_markers_PRESSED != null) {

			last_response_selected = null;

			document.getElementById("results").style.display = 'none';

			for (var i = 0; responseJson != null && i < responseJson.length; i++) {

				var data = responseJson[i];

				(function (i, data) {

					var icon = new ol.Feature({
						geometry: new ol.geom.Point(ol.proj.transform([data.lon, data.lat], 'EPSG:4326', 'EPSG:3857')),
					});
					icon.set('content', getContent(data));

					var iconLayerSource = new ol.source.Vector({
						features: [icon]
					});

					var iconLayer = new ol.layer.Vector({
						source: iconLayerSource,
						style: new ol.style.Style({
							image: new ol.style.Icon({
								src: pathMarkers + '/' + multi_markers_PRESSED + '.png',
								anchor: [0.4, 0.7],
								size: [64, 64],
								opacity: 1,
								scale: 0.8
							}),
						}),
						name: 'Marker' + (routeactive ? "Route" : "") + i
					});
					map.addLayer(iconLayer);


					map.on(is_mobile ? 'touchstart' : 'click', function (evt) {
						var feature = map.forEachFeatureAtPixel(evt.pixel, function (feature) {
							return feature;
						});
						if (feature) {
							var coordinates = feature.getGeometry().getCoordinates();
							document.getElementById('popup-content').innerHTML = feature.get('content');
							overlay.setPosition(coordinates);
						}
						else {
							if (!editingactive) overlay.setPosition(undefined);
						}
					});

					checkImageExists(pathMarkers + '/' + multi_markers_PRESSED + '.png', function (existsImage) {
						if (existsImage == true) {
							//
						}
						else {
							map.removeLayer(iconLayer);
							var iconLayer2 = new ol.layer.Vector({
								source: iconLayerSource,
								style: new ol.style.Style({
									image: new ol.style.Icon({
										src: pathMarkers + '/default/marker.png',
										anchor: [0.4, 0.7],
										size: [64, 64],
										opacity: 1,
										scale: 0.8
									}),
								}),
								name: 'Marker' + (routeactive ? "Route" : "") + i
							});
							map.addLayer(iconLayer2);
						}
					});

				})(i, data);
			}

			multi_markers_PRESSED = null;

		}
		// nel caso di ricerca generica (e posizione dinamica contenuto)
		else {

			if (responseJson.length > 0) document.getElementById("results").style.display = 'block';
			else document.getElementById("results").style.display = 'none';

			for (var i = 0; i < responseJson.length; i++) {

				data = responseJson[i];

				if (last_response_received != null && last_response_received.display_name == data.display_name) {
					if (data.address == null || data.address.city == null) continue;
					if (last_response_received.address == null || last_response_received.address.city == null) {
						try { document.getElementById("results").removeChild(document.getElementById("results").lastChild); } catch (errr) { }
						last_response_received = null;
					}
				}

				last_response_received = data;

				(function (i, data) {

					div = document.createElement("div");
					div.className = "olButtonRes";
					div.id = "cand" + i;
					div.innerHTML = data.display_name;

					div.onclick = function (evt) {

						document.getElementById("results").style.display = 'none';

						if (!routeactive) clearLayers();

						last_response_selected = data;

						if (endrouting == false) {
							map.getView().animate({
								zoom: zoom_iniziale,
								duration: 500
							});
							setTimeout(function () {
								map.getView().setCenter(ol.proj.transform([data.lon, data.lat], 'EPSG:4326', 'EPSG:3857'));
								map.getView().animate({
									zoom: zoom_iniziale + 2,
									duration: 1000
								})
							}, 510);
						}


						icona_marker = pathMarkers + '/' + data.type + '.png';
						if (startrouting) icona_marker = pathImages + 'start.png';
						else if (endrouting) icona_marker = pathImages + 'finish.png';

						marker_name = 'Marker' + i;
						if (startrouting) marker_name = 'MarkerStart';
						else if (endrouting) marker_name = 'MarkerFinish';

						var icon = new ol.Feature({
							geometry: new ol.geom.Point(ol.proj.transform([data.lon, data.lat], 'EPSG:4326', 'EPSG:3857'))
						});
						icon.set('content', getContent(data));

						var iconLayerSource = new ol.source.Vector({
							features: [icon]
						});

						var iconLayer = new ol.layer.Vector({
							source: iconLayerSource,
							style: new ol.style.Style({
								image: new ol.style.Icon({
									src: icona_marker,
									anchor: [0.4, 0.7],
									size: [64, 64],
									opacity: 1,
									scale: 0.8

								})
							}),
							name: marker_name
						});
						map.addLayer(iconLayer);

						iconLayer.setZIndex(100);

						checkImageExists(icona_marker, function (existsImage) {
							if (existsImage == true) {
								//
							}
							else {
								map.removeLayer(iconLayer);
								var iconLayer2 = new ol.layer.Vector({
									source: iconLayerSource,
									style: new ol.style.Style({
										image: new ol.style.Icon({
											src: pathMarkers + '/default/marker.png',
											anchor: [0.4, 0.7],
											size: [64, 64],
											opacity: 1,
											scale: 0.8
										}),
									}),
									name: 'Marker' + i
								});
								map.addLayer(iconLayer2);
							}
						});



						map.on(is_mobile ? 'touchsfvfart' : 'click', function (evt) {
							var feature = map.forEachFeatureAtPixel(evt.pixel, function (feature) {
								return feature;
							});
							if (feature) {
								var coordinates = feature.getGeometry().getCoordinates();
								document.getElementById('popup-content').innerHTML = feature.get('content');
								overlay.setPosition(coordinates);
							}
							else {
								if (!editingactive) overlay.setPosition(undefined);
							}
						});



						if (startrouting) {
							document.querySelector('#dest').value = "";
							document.querySelector('#dest').focus();
							startrouting = false;
							endrouting = true;
							startroutingpoint = data;
						}
						else if (endrouting) {
							startrouting = false;
							endrouting = false;
							endroutingpoint = data;
							geocodeRestOpenrouteservice("5b3ce3597851110001cf6248f3080d6e30864a8e9d18d5b82f5cb831", startroutingpoint.lon + "," + startroutingpoint.lat, endroutingpoint.lon + "," + endroutingpoint.lat);
						}


					};

					document.getElementById("results").appendChild(div);

					if (info_posizione_iniziale_dinamica) {
						div.click();
						document.getElementById("results").style.display = 'block';
						div.style.background = "#ffff00";
						info_posizione_iniziale_dinamica = false;
						posizione_iniziale_da_impostare = false;
					}


				})(i, data);

			}
			if (document.querySelector(idSearchInput) && searchString != document.querySelector(idSearchInput).value) geocodeRestSearch(document.querySelector(idSearchInput).value);
			else restCallReturned = true;
		}
	}

}

function geocodeRestOpenrouteservice(apikey, start, end) {

	document.getElementById("results").innerHTML = "";

	var url = 'https://api.openrouteservice.org/v2/directions/' + typerouting + '?api_key=' + apikey + '&start=' + start + '&end=' + end;

	var req = window.superagent;
	req.get(url, restGeoOpenrouteserviceResponse);
}

function restGeoOpenrouteserviceResponse(response) {
	var responseGeoJson = JSON.parse(response.text);

	var format = new ol.format.GeoJSON({
		featureProjection: "EPSG:3857"
	});
	var vectorSource = new ol.source.Vector({
		features: format.readFeatures(responseGeoJson)
	}
	);

	var vector_layer = new ol.layer.Vector({
		source: vectorSource,
		style: new ol.style.Style({
			stroke: new ol.style.Stroke({
				color: 'green',
				width: 5,
				opacity: 0.2
			})
		}),
		name: "Routing"
	});


	map.addLayer(vector_layer);

	steps = responseGeoJson.features[0].properties.segments[0].steps;

	distance_tot = 0;
	duration_tot = 0;

	if (steps.length > 0) {
		document.getElementById("results").style.display = 'block';
		distance_tot = responseGeoJson.features[0].properties.segments[0].distance;
		duration_tot = responseGeoJson.features[0].properties.segments[0].duration;
	}

	for (var i = 0; i < steps.length; i++) {

		data = steps[i];

		(function (i, data) {

			distance = data.distance;
			if (distance == 0) distance = "";
			else if (distance < 1000) distance = parseInt(distance) + " m";
			else distance = parseInt(distance / 1000) + " km e " + (parseInt(distance) % 1000) + " m";

			div = document.createElement("div");
			div.className = "olButtonRes";
			div.id = "route" + i;
			div.innerHTML = data.instruction.replace("Turn right onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_right.png' width='20' height='20' style='margin:2px' ></td><td valign='middle'>Gira a destra verso")
				.replace("Turn right", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira a destra")
				.replace("Turn left onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira a sinistra verso")
				.replace("Turn left", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira a sinistra")
				.replace("Head east on", "<table width='100%'><tr><td width='25' valign='middle'> </td><td valign='middle'>Dirigiti verso Est su")
				.replace("Head west on", "<table width='100%'><tr><td width='25' valign='middle'> </td><td valign='middle'>Dirigiti verso Ovest su")
				.replace("Head north on", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "north.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Dirigiti verso Nord su")
				.replace("Head south on", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "south.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Dirigiti verso Sud su")
				.replace("Turn sharp left onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_sharp_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira tutto a sinistra verso")
				.replace("Turn sharp right onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_sharp_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira tutto a destra verso")
				.replace("Turn sharp left", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_sharp_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira tutto a sinistra verso")
				.replace("Turn sharp right", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_sharp_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Gira tutto a destra verso")
				.replace("Keep left onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "keep_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Mantieni la sinistra verso")
				.replace("Keep right onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "keep_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Mantieni la destra verso")
				.replace("Keep left", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "keep_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Mantieni la sinistra")
				.replace("Keep right", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "keep_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Mantieni la destra")
				.replace("Turn slight left onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_slight_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Svoltare leggermente a sinistra verso")
				.replace("Turn slight right onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_slight_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Svoltare leggermente a destra verso")
				.replace("Turn slight left", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_slight_left.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Svoltare leggermente a sinistra")
				.replace("Turn slight right", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "turn_slight_right.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Svoltare leggermente a destra")
				.replace("Enter the roundabout and…", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi ")
				.replace("Enter the roundabout and...to", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi ")
				.replace("Enter the roundabout and...it", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi ")
				.replace("Enter the roundabout and take", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi ")
				.replace("Enter the roundabout and take the 1st exit", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi la prima uscita")
				.replace("Enter the roundabout and take the 2nd exit", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi la seconda uscita")
				.replace("Enter the roundabout and take the 3rd exit", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi la terza uscita")
				.replace("Enter the roundabout and take the 4th exit", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "roundabout.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Entra nella rotonda e prendi la quarta uscita")
				.replace("Continue straight onto", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "straight.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Continua dritto su")
				.replace("Arrive at your destination, on the right", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "ok.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Siamo arrivati, la tua destinazione si trova sulla destra")
				.replace("Arrive at your destination, on the left", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "ok.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Siamo arrivati, la tua destinazione si trova sulla sinistra")
				.replace("Arrive at", "<table width='100%'><tr><td width='25' valign='middle'><img src=" + pathImages + "ok.png' width='20' height='20' style='margin:2px'  ></td><td valign='middle'>Siamo arrivati a destinazione, su") +
				"</td><td valign='middle' align='right' width='50'><strong>" + distance + "</strong></td></tr></table>";

			div.onclick = function (evt) {

				overlay.setPosition(undefined);

			};

			document.getElementById("results").appendChild(div);

		})(i, data);

	}

	if (steps.length > 0) {
		if (distance_tot == 0) distance_tot = "0 metri";
		else if (distance_tot < 1000) distance_tot = parseInt(distance_tot) + " metri";
		else distance_tot = parseInt(distance_tot / 1000) + " km e " + (parseInt(distance_tot) % 1000) + " metri";

		if (duration_tot == 0) duration_tot = "0 secondi";
		else if (duration_tot < 60) duration_tot = parseInt(duration_tot) + " secondi";
		else if (duration_tot < 3600) duration_tot = parseInt(duration_tot / 60) + " minuti";
		else if (duration_tot < 86400) duration_tot = parseInt(duration_tot / 3600) + " ore e " + parseInt((parseInt(duration_tot) % 3600) / 60) + " minuti";
		else duration_tot = parseInt(duration_tot / 86400) + " giorni e " + (parseInt((duration_tot % 86400) / 3600)) + " ore e " + parseInt((parseInt((duration_tot % 86400)) % 3600) / 60) + " minuti";

		document.getElementById("infoRoute-container").style.display = "block";
		document.getElementById("infoRoute-container").innerHTML = "<img src=" + pathImages + "info.png' width='20' height='20' style='margin:7px' align='left' ><strong>" + distance_tot + "</strong><br><strong>in " + duration_tot + "</strong>";
		if (is_mobile) document.getElementById("buttonStartRout").style.display = "block";
	}
	map.getView().fit(vectorSource.getExtent(), {
		size: map.getSize(),
		padding: [0, 400, 0, 400],
		duration: 1000
	});

	vector_layer.setZIndex(0);
}

function checkImageExists(imageUrl, callBack) {
	var imageData = new Image();
	imageData.onload = function () {
		callBack(true);
	};
	imageData.onerror = function () {
		callBack(false);
	};
	imageData.src = imageUrl;
}

function getContent(data) {
	title = data.address.amenity;
	address = data.address.road + (data.address.neighbourhood != null ? ", " + data.address.neighbourhood : "") + (data.address.hamlet != null ? ", " + data.address.hamlet : "");
	phone = data.extratags.phone;
	website = data.extratags.website;
	type = data.type;
	country = data.address.country;
	city = data.address.city;

	if (title == null) title = data.display_name;
	if (address == null) address = " ";
	address = address.replace("undefined", "");

	if (phone == null) phone = " ";
	if (website == null) website = " ";
	if (type == null) type = " ";
	if (country == null) country = " ";

	if (city == null) city = data.address.county;
	if (city == null) city = " ";

	return content_markers_popup.replace(/#TITLE/g, title).replace(/#ADDRESS/g, address).replace(/#PHONE/g, phone).replace(/#WEBSITE/g, website).replace(/#TYPE/g, type).replace(/#CITY/g, city).replace(/#COUNTRY/g, country);
}

function getContentSave(lat, lon) {
	address = "";
	phone = "";
	website = "";
	country = "";
	country_code = "";
	city = "";
	neighborhood = "";
	region = "";
	postcode = "";

	if (last_response_selected) {
		address = last_response_selected.address.road;
		phone = last_response_selected.extratags.phone;
		website = last_response_selected.extratags.website;
		country = last_response_selected.address.country;
		country_code = last_response_selected.address.country_code;
		city = last_response_selected.address.city;
		neighborhood = last_response_selected.address.neighborhood;
		region = last_response_selected.address.state;
		postcode = last_response_selected.address.postcode;

		if (address == null) address = "";
		if (phone == null) phone = "";
		if (website == null) website = "";
		if (country == null) country = "";
		if (postcode == null) postcode = "";
		if (region == null) region = "";
		if (neighborhood == null) neighborhood = "";
		if (country_code == null) country_code = "";

		if (city == null) city = last_response_selected.address.county;
		if (city == null) city = "";
	}

	html = "<id id='save-container'>";
	html += "<input type='search' value='' placeholder='Nome luogo...' name='display_name' id='display_name' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + address + "' placeholder='Via...' name='road' id='road' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + city + "' placeholder='Città...' name='city' id='city'  style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + neighborhood + "' placeholder='Quartiere...' name='neighborhood' id='neighborhood'  style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + region + "' placeholder='Regione...' name='region' id='region'  style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + country + "' placeholder='Nazione...' name='country' id='country'  style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + country_code + "' placeholder='Codice Nazione...' name='country_code' id='country_code'  style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + postcode + "' placeholder='Codice postale...' name='postal_code' id='postal_code' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + phone + "' placeholder='Telefono...' name='phone' id='phone' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";
	html += "<input type='search' value='" + website + "' placeholder='Sito web...' name='website' id='website' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' ><br> ";

	html += "<font color='#1e6aa8'><strong>Type...</strong></font>";
	html += "<select name='type_amenity' id='type_amenity' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8; font-size: 8pt;'><option value=''></option>";
	for (var i = 0; i < categorie_luoghi.length; i++) html += "<option value='" + categorie_luoghi[i] + "'>" + categorie_luoghi_tradotti[i] + "</option>";
	html += "</select><br> ";

	html += "<input type='search' value='LAT " + lat + "' placeholder='Latitudine...' name='lat' id='lat' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' readonly ><br> ";
	html += "<input type='search' value='LON " + lon + "' placeholder='Longitudine... ' name='lon' id='lon' style='width: 100%; border: solid 1pt #1e6aa8; margin: 2px; color: #1e6aa8;' readonly ><br> ";

	html += "<button class='olButtonThisCat' id='buttonSavePlace'>Salva</button>";

	html += "</div>";

	return html;
}


// travelmode:
// 		driving, walking, bicycling, transit
// startlat, startlon:
//	    se NULL alora considera la posizione del dispositivo
function startNavigation(travelmode, startlat, startlon, destlat, destlon) {
	// If it's an iPhone..		  		   
	if (travelmode == "driving-car" || travelmode == "driving-hgv" || travelmode == "cycling-road") travelmode = "driving";
	else if (travelmode == "cycling-road") travelmode = "bicycling";
	else if (travelmode == "foot-walking") travelmode = "walking";
	else travelmode = "";

	var url = "";

	if ((navigator.platform.indexOf("iPhone") != -1)
		|| (navigator.platform.indexOf("iPod") != -1)
		|| (navigator.platform.indexOf("iPad") != -1)) {
		if (startlat == null && startlon == null) url = "maps://www.google.com/maps/dir/?api=1&travelmode=" + travelmode + "&layer=traffic&destination=" + destlat + "," + destlon + "&dir_action=navigate";
		else url = "maps://www.google.com/maps/dir/?api=1&travelmode=" + travelmode + "&layer=traffic&origin=" + startlat + "," + startlon + "&destination=" + destlat + "," + destlon + "&dir_action=navigate";
	}
	else {
		if (startlat == null && startlon == null) url = "https://www.google.com/maps/dir/?api=1&travelmode=" + travelmode + "&layer=traffic&destination=" + destlat + "," + destlon + "&dir_action=navigate";
		else url = "https://www.google.com/maps/dir/?api=1&travelmode=" + travelmode + "&layer=traffic&origin=" + startlat + "," + startlon + "&destination=" + destlat + "," + destlon + "&dir_action=navigate";
	}
	window.open(url);
}

function setStartStopIcon(start, stop) {
	var icon = new ol.Feature({
		geometry: new ol.geom.Point(ol.proj.transform([start.lon, start.lat], 'EPSG:4326', 'EPSG:3857'))
	});
	icon.set('content', getContent(start));

	var iconLayerSource = new ol.source.Vector({
		features: [icon]
	});

	var iconLayer = new ol.layer.Vector({
		source: iconLayerSource,
		style: new ol.style.Style({
			image: new ol.style.Icon({
				src: pathImages + 'start.png',
				anchor: [0.4, 0.7],
				size: [64, 64],
				opacity: 1,
				scale: 0.8
			})
		}),
		name: 'MarkerStart'
	});
	map.addLayer(iconLayer);

	iconLayer.setZIndex(100);



	icon = new ol.Feature({
		geometry: new ol.geom.Point(ol.proj.transform([stop.lon, stop.lat], 'EPSG:4326', 'EPSG:3857'))
	});
	icon.set('content', getContent(stop));

	iconLayerSource = new ol.source.Vector({
		features: [icon]
	});

	iconLayer = new ol.layer.Vector({
		source: iconLayerSource,
		style: new ol.style.Style({
			image: new ol.style.Icon({
				src: pathImages + 'finish.png',
				anchor: [0.4, 0.7],
				size: [64, 64],
				opacity: 1,
				scale: 0.8
			})
		}),
		name: 'MarkerFinish'
	});
	map.addLayer(iconLayer);

	iconLayer.setZIndex(100);
}

function setSizeMap() {
	if (!document.getElementById('map')) return;
	var myWidth = 0, myHeight = 0;
	if (document.getElementById('map').parentElement.nodeName.toLowerCase() == "body") {
		if (typeof (window.innerWidth) == 'number') {
			//Non-IE
			myWidth = window.innerWidth;
			myHeight = window.innerHeight;
		} else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
			//IE 6+ in 'standards compliant mode'
			myWidth = document.documentElement.clientWidth;
			myHeight = document.documentElement.clientHeight;
		} else if (document.body && (document.body.clientWidth || document.body.clientHeight)) {
			//IE 4 compatible
			myWidth = document.body.clientWidth;
			myHeight = document.body.clientHeight;
		}
		document.getElementById("map").style.width = (myWidth - 20) + "px";
		document.getElementById("map").style.height = (myHeight - 20) + "px";
		document.body.style.overflow = "hidden";
	}
	else {
		myWidth = document.getElementById('map').parentElement.clientWidth;
		myHeight = document.getElementById('map').parentElement.clientHeight;
		/*     document.getElementById("map").style.width = (myWidth - 20) + "px";
			document.getElementById("map").style.height = (myHeight - 20) + "px"; */
		document.getElementById("map").style.width = myWidth + "px";
		document.getElementById("map").style.height = myHeight + "px";
		document.getElementById('map').parentElement.style.overflow = "hidden";
	}
}

function addSourceToMap(map) {

	try {
		sourceGeoLocalization = new ol.source.Vector();
		const layer = new ol.layer.Vector({
			source: sourceGeoLocalization,
		});
		map.addLayer(layer);
	} catch (error) {
		console.log('error:', error);
	}


}

function addGeolocationBtn() {
	try {
		const locate = document.createElement('div');
		locate.className = 'ol-control ol-unselectable locate';
		locate.innerHTML = '<button title="Locate me">◎</button>';
		locate.addEventListener('click', function () {
			if (!sourceGeoLocalization.isEmpty()) {
				map.getView().fit(sourceGeoLocalization.getExtent(), {
					maxZoom: 18,
					duration: 500,
				});
			}
		});
		map.addControl(
			new ol.control.Control({
				element: locate,
			})
		);
	} catch (error) {
		console.log('error:', error);
	}




}

function watchPosition(geolocation) {
	firstLocationInterval = checkLocationInterval();
	watchPositionRef = geolocation.watchPosition().subscribe((pos) => {
		// luogo_iniziale = null;
		/* 	if (isFirstLocation) {
				longitudine_iniziale = pos?.coords?.longitude;
				latitudine_iniziale = pos?.coords?.latitude;
				if (longitudine_iniziale && latitudine_iniziale) {
					setPosition()
				}
				isFirstLocation = false
			} */
		if (firstLocationInterval) {
			clearInterval(firstLocationInterval)
		}

		if (locationInterval) {
			locationInterval.forEach(li => {
				clearInterval(li)
				locationInterval = locationInterval.filter(lif => lif !== li)
			})
		}
		locationInterval.push(checkLocationInterval())
		if (pos?.coords) {
			const coords = [pos?.coords?.longitude, pos?.coords?.latitude];
			const accuracy = new ol.geom.Polygon.circular(coords, pos.coords.accuracy);
			const point = new ol.geom.Point(ol.proj.fromLonLat(coords))
			sourceGeoLocalization.clear(true);
			sourceGeoLocalization.addFeatures([
				new ol.Feature(
					accuracy.transform('EPSG:4326', map.getView().getProjection())
				),
				new ol.Feature(point),
			]);
		}
	}, (err) => {
		console.log('err:', err);

		if (firstLocationInterval) {
			clearInterval(firstLocationInterval)
		}

		if (locationInterval) {
			locationInterval.forEach(li => {
				clearInterval(li)
				locationInterval = locationInterval.filter(lif => lif !== li)
			})
		}
		showErrorToastFunc(err.message)
	});
}

function getWatchPositionRef() {
	return watchPositionRef
}

function checkLocationInterval() {
	const inervalReference = setInterval(() => {
		showErrorToastFunc('Abilitare la geolocalizzazione')
		clearInterval(inervalReference)
	}, duration_geolocalization_check)

	return inervalReference
}

function getLocationIntervalRef() {
	return [firstLocationInterval, ...locationInterval]
}
