import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { Geolocation } from '@awesome-cordova-plugins/geolocation/ngx';
import { IonicModule } from '@ionic/angular';
import { ButtonsCatPoiModule } from 'src/app/components';

import { HeaderModule } from '../../../components';
import { PoiPageRoutingModule } from './poi-routing.module';
import { PoiPage } from './poi.page';

@NgModule({
	imports: [CommonModule, FormsModule, IonicModule, PoiPageRoutingModule, ButtonsCatPoiModule, HeaderModule],
	declarations: [PoiPage],
	providers: [Geolocation],
})
export class PoiPageModule {}
